-- name: [CS] Koraidon
-- description: A legendary pokemon from Paldea\n\n\\#11965f\\This Pack requires Character Select\nto use as a Library!

--[[
    API Documentation for Character Select can be found below:
    https://github.com/Squishy6094/character-select-coop/blob/main/API-doc.md

    Use this if you're curious on how anything here works >v<
]]

local E_MODEL_Koraidon = smlua_model_util_get_id("Koraidon_geo")

local TEX_Koraidon_ICON = get_texture_info("Koraidon-icon")

local TEXT_MOD_NAME = "Koraidon "

local VOICETABLE_Koraidon = {
   --[CHAR_SOUND_OKEY_DOKEY] = 'StartLevel.ogg', -- Starting game
    [CHAR_SOUND_LETS_A_GO] = nil, -- Starting level
    [CHAR_SOUND_OOOF] = 'Dano 1.ogg',
    [CHAR_SOUND_OOOF2] = nil,
    [CHAR_SOUND_WAH2] ='Agarre borde.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'Golpe 1.ogg', -- Punch 1
    [CHAR_SOUND_PUNCH_WAH] = 'Golpe 2.ogg', -- Punch 2
    [CHAR_SOUND_PUNCH_HOO] = 'Golpe 3.ogg', -- Punch 3
    [CHAR_SOUND_YAH_WAH_HOO] = {'Salto 1.ogg', 'Salto 2.ogg'}, -- First/Second jump sounds
    [CHAR_SOUND_HOOHOO] = 'Salto 2.ogg', -- Third jump sound
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = 'Salto 3.ogg', -- Triple jump sounds
    [CHAR_SOUND_UH] = 'WallJump.ogg', -- Wall bonk
    [CHAR_SOUND_UH2] = nil, -- Landing after long jump
    [CHAR_SOUND_UH2_2] = 'Agarre borde.ogg', -- Same sound as UH2; jumping onto ledge
    [CHAR_SOUND_HAHA] = nil, -- Landing triple jump
    [CHAR_SOUND_YAHOO] = 'Salto 3.ogg', -- Long jump
    [CHAR_SOUND_HAHA_2] = nil,
    [CHAR_SOUND_DOH] = 'WallJump.ogg', -- Long jump wall bonk
    [CHAR_SOUND_WHOA] = 'Agarre borde.ogg', -- Grabbing ledge
    [CHAR_SOUND_EEUH] = nil, -- Climbing over ledge
    [CHAR_SOUND_WAAAOOOW] = 'Caida Larga.ogg', -- Falling a long distance
    [CHAR_SOUND_TWIRL_BOUNCE] = nil, -- Bouncing off of a flower spring
    [CHAR_SOUND_GROUND_POUND_WAH] = nil, 
    [CHAR_SOUND_HRMM] = 'Dano 1.ogg', -- Lifting something
    [CHAR_SOUND_HERE_WE_GO] = 'Victoria.ogg', -- Star get
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'Golpe 2.ogg', -- Throwing Bowser
--DAMAGE
    [CHAR_SOUND_ATTACKED] = 'Dano 1.ogg', -- Damaged
    [CHAR_SOUND_PANTING] = 'Vida baja.ogg', -- Low health
    [CHAR_SOUND_ON_FIRE] = 'Dano 2.ogg', -- Burned
--SLEEP SOUNDS
    [CHAR_SOUND_IMA_TIRED] = nil, -- Mario feeling tired
    [CHAR_SOUND_YAWNING] = nil, -- Mario yawning before he sits down to sleep
    [CHAR_SOUND_SNORING1] = nil, -- Snore Inhale
    [CHAR_SOUND_SNORING2] = nil, -- Exhale
    [CHAR_SOUND_SNORING3] = nil, -- Sleep talking / mumbling
--COUGHING (USED IN THE GAS MAZE)
    [CHAR_SOUND_COUGHING1] = nil, -- Cough take 1
    [CHAR_SOUND_COUGHING2] = nil, -- Cough take 2
    [CHAR_SOUND_COUGHING3] = nil, -- Cough take 3
--DEATH
    [CHAR_SOUND_DYING] = nil, -- Dying from damage
    [CHAR_SOUND_DROWNING] = nil, -- Running out of air underwater
    [CHAR_SOUND_MAMA_MIA] = nil -- Booted out of level
}

local PALETTE_Koraidon = {
    [PANTS]  = "374DF4",
    [SHIRT]  = "2B2D33",
    [GLOVES] = "374DF4",
    [SHOES]  = "FFFFFF",
    [HAIR]   = "871D6A",
    [SKIN]   = "FA5045",
    [CAP]    = "301A43",
}

--[[ Koraidon does NOT take his hat off under ANY circumstances, as canonically, hatless Koraidon is a horrid sight.
local CAPTABLE_Koraidon = {
    normal = smlua_model_util_get_id("Koraidon_cap_normal_geo"),
    wing = smlua_model_util_get_id("Koraidon_cap_wing_geo"),
    metal = smlua_model_util_get_id("Koraidon_cap_metal_geo"),
    metalWing = smlua_model_util_get_id("Koraidon_cap_wing_geo"),
}
--]]
if _G.charSelectExists then
    CT_CHAR = _G.charSelect.character_add("Koraidon ", "A legendary pokemon from Paldea", "Made by @Asplatim on twitter", {r = 234, g = 77, b = 69}, E_MODEL_Koraidon, CT_MARIO, TEX_Koraidon_ICON)
--      _G.charSelect.character_add_caps(E_MODEL_Koraidon, CAPTABLE_Koraidon)

    _G.charSelect.character_add_palette_preset(E_MODEL_Koraidon, PALETTE_Koraidon)

     --the following must be hooked for each character added

    _G.charSelect.character_add_voice(E_MODEL_Koraidon, VOICETABLE_Koraidon)
    hook_event(HOOK_CHARACTER_SOUND, function (m, sound)
        if _G.charSelect.character_get_voice(m) == VOICETABLE_Koraidon then return _G.charSelect.voice.sound(m, sound) end
    end)
    hook_event(HOOK_MARIO_UPDATE, function (m)
        if _G.charSelect.character_get_voice(m) == VOICETABLE_Koraidon then return _G.charSelect.voice.snore(m) end
    end)
else
    djui_popup_create("\\#ffffdc\\\n"..TEXT_MOD_NAME.."\nRequires the Character Select Mod\nto use as a Library!\n\nPlease turn on the Character Select Mod\nand Restart the Room!", 6)
end